--
-- wipers
-- Specialization class for MF 1200 and 1250 wipers
--
-- @author  PeterJ - euroDZN
-- @date  18/02/2014
--
-- http://eurodzn.wordpress.com/
--
-- Copyright (C) euroDZN, Confidential, All Rights Reserved.

wipers = {};

function wipers.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(InteractiveControl, specializations) and SpecializationUtil.hasSpecialization(AnimatedVehicle, specializations);
end;

function wipers:load(savegame)

    self.wipersAnim = getXMLString(self.xmlFile, "vehicle.wipers#animationName");
    self.wipersButton = getXMLString(self.xmlFile, "vehicle.wipers#buttonAnim");
    self.wipersSpeed = getXMLFloat(self.xmlFile, "vehicle.wipers#speed");
    self.isWiperOn = false;
    self.turnWiperOn = false;
    self.buttonAnimTime = 0;
end;

function wipers:delete()
end;

function wipers:mouseEvent(posX, posY, isDown, isUp, button)
end;

function wipers:keyEvent(unicode, sym, modifier, isDown)
end;

function wipers:update(dt)
end;

function wipers:updateTick(dt)

    if self:getIsActive() then
        local animTime = self:getAnimationTime(self.wipersButton);
        if animTime > self.buttonAnimTime then
            if not self.isWiperOn then
                self.isWiperOn = true;
            end;
        elseif animTime < self.buttonAnimTime then
            if self.isWiperOn then
                self.isWiperOn = false;
            end;
        end;
        if self.isWiperOn then
            if not self:getIsAnimationPlaying(self.wipersAnim) then
                self:playAnimation(self.wipersAnim, self.wipersSpeed, 0, true);
            end;
        end;
        self.buttonAnimTime = animTime;
        
        if g_currentMission.environment.lastRainScale > 0.1 and g_currentMission.environment.timeSinceLastRain < 30 then
            if not self.isWiperOn then
                self.turnWiperOn = true;
            else
                self.turnWiperOn = false;
            end;
        else
            if self.turnWiperOn then
                self.turnWiperOn = false;
            end;
        end;
    end;
end;

function wipers:draw()
    if self.turnWiperOn then
        g_currentMission:addExtraPrintText(g_i18n:getText("TurnWipersOn"));
    end;
end;